﻿using MarkdownDeep;
using Microsoft.Extensions.Configuration;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Net.Http.Json;
using System.Text;
using System.Threading.Tasks;

namespace ContentGenerator
{
    public class Program
    {
        private const string _inputFile = "results.json"; // Set to "input.json" if using a local inference server.
        private const string _imageApiBaseUrl = "https://api.unsplash.com";
        private const string _localInferenceApiBaseUrl = "http://localhost:1234";

        public static async Task Main()
        {
            var config = new ConfigurationBuilder().AddJsonFile("appsettings.json").Build();
            var imageApiKey = config["ImageApiKey"];

            var items = JsonConvert.DeserializeObject<List<Item>>(File.ReadAllText(_inputFile));

            var path = @"./content";
            Directory.CreateDirectory(path);
            
            var dayOffset = -items.Count;

            var markdownRemover = new Markdown()
            {
                SummaryLength = -1
            };

            foreach (var item in items)
            {
                var textGenerationSource = "Phind";
                var filename = $"{ConvertTextToSlug(item.Title)}.md";
                var fullPath = Path.Join(path, filename);
                var publishDate = DateTime.UtcNow.AddDays(dayOffset).ToString("yyyy-MM-dd");
                dayOffset++;

                var title = item.Title.Replace("\"", "\\\"");                
                var excerpt = string.Empty;

                if (string.IsNullOrEmpty(item.Result))
                {
                    Console.WriteLine($"Generating text using the prompt: \"{item.Prompt}\".  This may take a few minutes...");
                    item.Result = await GenerateTextViaLocalInferenceApi(item.Prompt);
                    if (!string.IsNullOrEmpty(item.Result))
                    {
                        Console.WriteLine("Completed generating text.");
                        textGenerationSource = "Local Inference Server";
                    }
                }

                excerpt = FirstWords(markdownRemover.Transform(item.Result).Replace("\"", "\\\""), 20);
                var imageResult = await GetImageResultByKeyword(item.ImageSearch, imageApiKey);
                var imageUrl = imageResult != null
                    ? $"{imageResult.urls.raw}&auto=format&fit=crop&w=2070&q=80"
                    : string.Empty;
                var photoCredit = string.Empty;

                if (!string.IsNullOrEmpty(imageUrl))
                {
                    photoCredit = @$"Photo by <a href=""https://unsplash.com/@{imageResult.user.username}?utm_source=Keyword%20Search&utm_medium=referral"">{imageResult.user.name}</a> on <a href=""https://unsplash.com/?utm_source=Keyword%20Search&utm_medium=referral"">Unsplash</a>";
                }                

                var fileContent = @$"---
publishDate: {publishDate}T00:00:00Z
title: ""{item.Title}""
excerpt: ""{excerpt}...""
image: {imageUrl}
---

{photoCredit}

# {item.Title}

{item.Result}

**Generated by {textGenerationSource} using the prompt:** {item.Prompt}";

                using var writer = new StreamWriter(fullPath);
                writer.WriteLine(fileContent);

                Console.WriteLine($"Generated content page: {filename}");
            }

            Console.WriteLine("Processing complete!");
        }

        // Source: https://www.codeproject.com/Articles/80882/Converting-Text-to-a-URL-Slug
        public static string ConvertTextToSlug(string s)
        {
            var sb = new StringBuilder();
            var wasHyphen = true;
            foreach (char c in s)
            {
                if (char.IsLetterOrDigit(c))
                {
                    sb.Append(char.ToLower(c));
                    wasHyphen = false;
                }
                else if (char.IsWhiteSpace(c) && !wasHyphen)
                {
                    sb.Append('-');
                    wasHyphen = true;
                }
            }

            // Avoid trailing hyphens
            if (wasHyphen && sb.Length > 0)
            {
                sb.Length--;
            }

            return sb.ToString();
        }

        // Source: https://www.dotnetperls.com/first-words
        public static string FirstWords(string input, int numberWords)
        {
            // Number of words we still want to display.
            int words = numberWords;
            // Loop through entire summary.
            for (int i = 0; i < input.Length; i++)
            {
                // Increment words on a space.
                if (input[i] == ' ')
                {
                    words--;
                }
                // If we have no more words to display, return the substring.
                if (words == 0)
                {
                    return input.Substring(0, i);
                }
            }
            
            return string.Empty;
        }

        public static async Task<ImageSearchResult.Result> GetImageResultByKeyword(string keyword, string imageApiKey)
        {
            ImageSearchResult.Result imageResult = null;

            using var client = new HttpClient();
            client.BaseAddress = new Uri(_imageApiBaseUrl);
            
            client.DefaultRequestHeaders.Accept.Add(
                new MediaTypeWithQualityHeaderValue("application/json"));
            
            var response = await client.GetAsync($"/search/photos?client_id={imageApiKey}&query={keyword}&page=1&per_page=1");  
            if (response.IsSuccessStatusCode)
            {
                var result = await response.Content.ReadFromJsonAsync<ImageSearchResult.Root>();
                if (result.results.Any())
                {
                    imageResult = result.results.FirstOrDefault();
                }
            }
            else
            {
                Console.WriteLine($"Error fetching an image result: {response.StatusCode} ({response.ReasonPhrase}).  Please check the ImageApiKey.");
            }

            return imageResult;
        }

        public static async Task<string> GenerateTextViaLocalInferenceApi(string prompt)
        {
            string messageResult = null;
            var promptGuidelines = "You are an expert at writing blog posts.  Limit the maximum overall words generated to 500.  Do not number the paragraphs (e.g. 'Paragraph 1, Paragraph 2, etc.' or '1, 2, etc.') when writing.";

            var parameters = new GeneratedTextRequest
            {
                Messages = new List<GeneratedTextRequestMessage>
                {
                    new GeneratedTextRequestMessage
                    {
                        Role = "user",
                        Content = $"{promptGuidelines} {prompt}"
                    }
                }
            };

            try
            {
                using var client = new HttpClient();
                client.Timeout = TimeSpan.FromMinutes(5);
                client.BaseAddress = new Uri(_localInferenceApiBaseUrl);
                
                client.DefaultRequestHeaders.Accept.Add(
                    new MediaTypeWithQualityHeaderValue("application/json"));
                
                var jsonSerializerSettings = new JsonSerializerSettings 
                { 
                    ContractResolver = new CamelCasePropertyNamesContractResolver() 
                };
                
                var response = await client.PostAsync(
                    $"/v1/chat/completions",
                    new StringContent(
                        JsonConvert.SerializeObject(parameters, jsonSerializerSettings), 
                        Encoding.UTF8, 
                        "application/json")
                );

                if (response.IsSuccessStatusCode)
                {                
                    var result = await response.Content.ReadFromJsonAsync<GeneratedTextResult.Root>();
                    if (result.choices.Any())
                    {
                        messageResult = result.choices.FirstOrDefault()?.message.content;
                    }
                }
                else
                {
                    Console.WriteLine($"Error fetching generated text: {response.StatusCode} ({response.ReasonPhrase}).  Please ensure the local inference API is running properly.");
                }
            }
            catch (Exception e)
            {
                Console.WriteLine($"Error fetching generated text: {e.Message}.  Please ensure the local inference API is started at '{_localInferenceApiBaseUrl}'.");
            }

            return messageResult;
        }
    }

    public class Item
    {
        public string Title { get; set; }

        public string ImageSearch { get; set; }

        public string Prompt { get; set; }

        public string Result { get; set; }
    }

    public class GeneratedTextRequest
    {
        public List<GeneratedTextRequestMessage> Messages { get; set; }

        public int max_tokens = 1000;

        public float temperature = 0.7f;

        public bool stream = false;
    }

    public class GeneratedTextRequestMessage
    {
        public string Role { get; set; }

        public string Content { get; set; }
    }
}